# Change Log
Cambios sobre kit de integración de CLAVE2 en tecnología Java 8

## [2.2.4] - 26-JUL-2024
-- UH26987-320_Mantenimiento_Kits_de_integración_certificado_SGAD_PRUEBAS
 - En el kit Java8 v2.2.4 se lleva a cabo la actualización del certificado SELLO ENTIDAD SGAD PRUEBAS (5f214302218d9201664355e30e5408a7)

## [2.2.3] - 04-MAY-2023
-- VY26777-114_Mantenimiento_Inc_1892188_Cortes_acceso_plataforma_Clave_PRE
 - El cliente nos comunica que tenemos que actualizar el documento del manual de integración, para especificar claramente que es obligatorio enviar la cabecera 'referer', tal como se muestra en el archivo en formato HAR (HTTP Archive) de la petición. Por tanto, se añade el nuevo apartado '3.2.1.Detalle de la cabecera enviada des del SP2 hacia CLAVE PASARELA (PROXY2) en el entorno de PRE WILDFLY' del documento. Dentro de este apartado, se muestra el ejemplo de la petición HAR en cuestión.
 
## [2.2.2] - 15-FEB-2023
-- VY26777-37_Mantenimiento_Incidencia_#1709763_Version_java8_Clave
 - Actualización de las librerías de clave-j20068.saml-engine de la versión 2.7 a la 2.8.4 para que hagan uso de Opensaml3

## [2.2.1] - 19-AGO-2022 // 21-SEP-2022
-- CLV20-307_Kit_Java_Actualizacion_automatica_de_certificados_en_SP
 - PROYECTO CLAVE: Se desarrolla un evolutivo que permite distribuir hacia los diferentes SP, los certificados (parte pública) que usa Cl@ve para firmar sus mensajes.
 - PROYECTO INTEGRADOR JAVA: Para reducir la comunicación con los SP cuando se renuevan los certificados de CLAVE, se hará uso de la nueva evolución del proyecto CLAVE mencionada en el parágrafo anterior.
 - Los certificados, existentes en la BDD de CLAVE, se obtendrán a través de una URL que invocará un servlet y se devolverán a través de un XML en formato BASE64. Una vez parseados estos certificados se compararán con los ya existentes en el repositorio de certificados del Integrador, y utilizando un algoritmo se actualizarán o no.
 - El repositorio de certificados del Integrador será una carpeta configurable, la cual contendrá un fichero de control utilizado por el algoritmo.
 - La ejecución de dicho algoritmo de recuperación y actualización de certificados para los SPs será periódica y a través de un proceso de tipo Daemon. Su intervalo de ejecución será configurable y por defecto cada 24 horas.
 - En las siguientes páginas se dan todos los detalles técnicos y funcionales destacados para el desarrollo de esta nueva funcionalidad del Integrador de Java.
-----------------------------
 - Se ha adaptado el código del integrador de Java 8 para CLAVE, pasando de la 'v1.4.3-clave' a la nueva 'v2.6.10'
 - Para ello se ha modificado el 'pom.xml' de la raíz, y se han incorporado en la carpeta 'Dependencias' de este repositorio las librerías 'es.gob.sgad.clave-j20068.clave-saml-parent', 'es.gob.sgad.clave-j20068.commons' y 'es.gob.sgad.clave-j20068.saml-engine', que son generadas en el repositorio de CLAVE y utilizadas por este repositorio del INTEGRADOR. Se han descargado directamente des del Nexus.
-----------------------------
 - Para que el integrador funcione, tiene que existir la siguiente variable de sistema dentro de las variables de entorno del sistema operativo:
   - CLAVE_SP2_CONFIG_REPOSITORY: path donde se encuentran los ficheros de configuración del proyecto
 - El único módulo 'SP2' existente en el proyecto del Integrador de Java 8, ya está provisto de Spring Framework, pero se añade la siguiente configuración para que se escaneen las clases dentro del package 'es.clave.sp.daemon':
   - 'applicationContext.xml' -> '<context:component-scan base-package="es.clave.sp" />'
   - 'DaemonConfig.java' -> Es una clase de configuración (tag '@Configuration') con la única finalidad de ser escaneada por el Spring e indicarle a través del tag '@EnableScheduling' que se pueda ejecutar el Daemon.
 - Se crea la clase 'DaemonCertificateProxy2.java' que contiene el proceso daemon a ejecutar periódicamente (a través del tag Spring '@Scheduled') y que se encargará de conectarse al módulo 'Proxy2' de CLAVE a través de una URL y así descargarse los certificados públicos de firma y de cifrado. En LOC, por ejemplo, esta URL es: 'http://localhost:8888/Proxy2/Certificates' (sin seguridad) o 'https://localhost:8443/Proxy2/Certificates' (con seguridad)
 - Este proceso daemon se ejecutará siempre y cuando la propiedad 'certProxy2.daemon.activated' del fichero 'certproxy2.properties' tenga el valor de 'true'.
 - En el fichero 'securityConf.xml' se añade la nueva propiedad 'certProxy2.daemon.fixedRate' que indicará el tiempo en milisegundos de la periodicidad en que se debe ejecutar el daemon 'DaemonCertificateProxy2'. Por defecto se establece en que se ejecute una vez al día (86400000 ms).
 - Se crea el nuevo fichero de configuración 'certproxy2.properties' donde se establecen las siguientes propiedades:
    # URL DE DONDE DESCARGAR LOS CERTIFICADOS
    # LOC
    #certproxy2.endpoint=http://localhost:8888/Proxy2/Certificates
    certproxy2.endpoint=https://localhost:8443/Proxy2/Certificates
    # INT
    #certproxy2.endpoint=https://des-clave2.redsara.es/Proxy2/Certificates
    # PRE
    #certproxy2.endpoint=https://pre-pasarela.clave.gob.es/Proxy2/Certificates
    # SE
    #certproxy2.endpoint=https://se-pasarela.clave.gob.es/Proxy2/Certificates
    # PRO
    #certproxy2.endpoint=https://pasarela.clave.gob.es/Proxy2/Certificates

    # PATH DEL KEYSTORE CON LOS SSL DE ACCESO. TIENE COMO PATH BASE LA CARPETA './Config/'
    truststore.path=TrustStore.jks

    # PASSWORD DEL KEYSTORE 'TrustStore.jks'
    truststore.password=local-demo

    # DIRECTORIO DONDE GUARDAR LOS CERTIFICADOS DESCARGADOS
    certificates.path=C:/work/repos/_bitbucket_/clave/integradores/24981_clave_integra_desarrollo-de-nue/paquete_sp_java_8/Paquete_Integracion_Java_Clave_8/Certificates

    # FLAG PARA ACTIVAR O DESACTIVAR EL NUEVO PROCESO: true / false
    certProxy2.daemon.activated=true
-----------------------------
 - En el daemon 'DaemonCertificateProxy2' se abre una conexión HTTP de tipo GET que consume el servlet ofrecido por el módulo 'Proxy2' de CLAVE2. La URL de esta conexión se configura en la propiedad 'certproxy2.endpoint' del fichero 'certproxy2.properties'.
 - A través de esta llamada obtenemos un XML con los diferentes certificados públicos existentes en la BDD de CLAVE. Estos pueden estar activos (código 2) o inactivos (código 3). Básicamente se obtiene la siguiente información:
   - tipo de certificado: de firma (signing), o de cifrado (encryption)
   - nombre del certificado: 'proxy_sign_*' o 'proxy_cipher_*'
   - contenido del certificado en Base64
   - estado certificado: activo / inactivo
-----------------------------
 - A continuación se muestra un ejemplo de XML de certificados devuelto por el servlet de PROXY2 / CLAVE2 a través de la llamada a la URL 'https://localhost:8443/Proxy2/Certificates':
    <md:EntityDescriptor entityID="https://localhost:8443/Proxy2/Certificates">
        <md:IDPSSODescriptor protocolSupportEnumeration="urn:oasis:names:tc:SAML:2.0:protocol">
            <md:KeyDescriptor use="signing">
                <ds:KeyInfo>
                    <ds:KeyName>proxy_sign_58764336</ds:KeyName>
                    <ds:X509Data>
                        <ds:X509Certificate>
                            MIIDQTCCAikCBFcx/LAwDQYJKoZIhvcNAQELBQAwZTELMAkGA1UEBhMCRVMxDz...
                        </ds:X509Certificate>
                    </ds:X509Data>
                    <ds:MgmtData>active</ds:MgmtData>
                </ds:KeyInfo>
            </md:KeyDescriptor>
            <md:KeyDescriptor use="signing">
                <ds:KeyInfo>
                    <ds:KeyName>proxy_sign_5731fcb0</ds:KeyName>
                    <ds:X509Data>
                        <ds:X509Certificate>
                            MIIDQTCCAikCBFcx/LAwDQYJKoZIhvcNAQELBQAwZTELMAkGA1UEBhMCRVMxDzANBgNVBAgMB...
                        </ds:X509Certificate>
                    </ds:X509Data>
                    <ds:MgmtData>inactive</ds:MgmtData>
                </ds:KeyInfo>
            </md:KeyDescriptor>
            <md:KeyDescriptor use="encryption">
                <ds:KeyInfo>
                    <ds:KeyName>proxy_cipher_5731fcb0</ds:KeyName>
                    <ds:X509Data>
                        <ds:X509Certificate>
                            MIIDQTCCAikCBFcx/LAwDQYJKoZIhvcNAQELBQAwZTELMAkGA1UEBh...
                        </ds:X509Certificate>
                    </ds:X509Data>
                    <ds:MgmtData>active</ds:MgmtData>
                </ds:KeyInfo>
            </md:KeyDescriptor>
            <md:KeyDescriptor use="encryption">
                <ds:KeyInfo>
                    <ds:KeyName>proxy_cipher_58764336</ds:KeyName>
                    <ds:X509Data>
                        <ds:X509Certificate>
                            MIIDQTCCAikCBFcx/LAwDQYJKoZIhvcNAQELBQAwZTELMAkGA1U...
                        </ds:X509Certificate>
                    </ds:X509Data>
                    <ds:MgmtData>inactive</ds:MgmtData>
                </ds:KeyInfo>
            </md:KeyDescriptor>
            <md:Organization>
                <md:OrganizationName xml:lang="en">
                    General Secretariat of Digital Administration - Ministry of Territorial Policy and Civil Service
                </md:OrganizationName>
                <md:OrganizationDisplayName xml:lang="en">
                    General Secretariat of Digital Administration - Ministry of Territorial Policy and Civil Service
                </md:OrganizationDisplayName>
                <md:OrganizationURL xml:lang="en">
                    https://administracionelectronica.gob.es/pae_Home/pae_Organizacion/SGAD.html
                </md:OrganizationURL>
            </md:Organization>
        </md:IDPSSODescriptor>
    </md:EntityDescriptor>
-----------------------------
 - En la clase 'DaemonCertificateProxy2' se ha desarrollado el algoritmo de actualización y recuperación de certificados públicos. Su funcionamiento es el siguiente:
   - Por una parte, se recuperan los pares atributo/valor del fichero 'certificates.properties'. Este fichero se encuentra en el path de certificados.
   - Por otra parte, se hace la llamada tipo GET al servlet de PROXY2 de CLAVE que devuelve un XML con los certificado públicos de firma y de cifrado. La URL a llamar está indicada en la variable 'certproxy2.endpoint' del fichero 'certproxy2.properties'.
   - Se parsea el XML devuelto a través de la librería DOM Parser para obtener el tipo de certificado (firma o cifrado), el nombre, el estado (activo o inactivo), y el certificado en BASE64.
   - Si el nombre del certificado obtenido a través del XML existe en el fichero de propiedades 'certificates.properties'...
      - Si el estado del certificado obtenido es igual al del fichero de propiedades...
         - Se informa en el log que el certificado de firma o de cifrado ya existe
      - Si el estado del certificado obtenido es diferente al del fichero de propiedades...
         - Se descarga el certificado en el repositorio local de certificados (se sobreescribe), y se actualiza la info del certificado en el fichero 'certificates.properties' con el nombre, el estado y la fecha de actualización.
         - Se informa en el log que se ha actualizado el certificado de firma
   - Si el nombre del certificado obtenido a traves del XML no existe en el fichero de propiedades 'certificates.properties'...
      - Se descarga el certificado en el repositorio local de certificados, y se inserta la info del certificado en el fichero 'certificates.properties' con el nombre, el estado y la fecha de actualización.
      - Se informa en el log que se ha descargado el certificado de firma
-----------------------------
 - En el daemon 'DaemonCertificateProxy2' se ha añadido la parte de código que permite hacer llamadas seguras al módulo Proxy2 de CLAVE2 a través de una URL de tipo 'https'. Para este tipo de llamadas se necesita de un solo almacén de certificados de confianza 'TrustStore.jks', que contiene los certificados públicos de todos los entornos (LOC, INT, PRE, SE y PRO), los cuales se han descargado directamente del navegador a través de las diferentes URLs (en caso de LOC: 'https://localhost:8443/Proxy2/Certificates').
 - Para configurar este almacén de confianza, hay dos parámetros en el fichero de propiedades 'Config\certproxy2.properties':
     # Path del keystore con los SSL de acceso. Tiene como path base la carpeta '.../Config/'
     truststore.path=TrustStore.jks
     # Password del keystore 'TrustStore.jks'
     truststore.password=local-demo

---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
-- CLV21-29_Implementacion_IDP_Clave_Autenticador_Movil
 - En la pantalla del SP2 de prueba del KIT de Integración de Java, se ha añadido el checkbox 'IDP Móvil' en el apartado 'Deshabilitar IdPs'. Si se selecciona, permite esconder el IDP Móvil en la pantalla Pasarela, en caso de que el SP lo tuviera configurado. El código que se le añade a la petición SAML, si se selecciona este checkbox, es el siguiente:
    reqAttrMapBuilder.put(new AttributeDefinition.Builder<String>().nameUri("http://es.minhafp.clave/CLVMOVILIdP")
        .friendlyName("CLVMOVILIdP")
        .personType(PersonType.NATURAL_PERSON)
        .required(false)
        .uniqueIdentifier(true)
        .xmlType("http://www.w3.org/2001/XMLSchema", "CLVMOVILIdP", "cl")
        .attributeValueMarshaller(new StringAttributeValueMarshaller())
        .build());



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.1.4] - 21-JUN-2022 // 21-SEP-2022
-- CLV21-142_Caducidad_certificado_firma_INT_PRE
 - Se configura de serie el Kit de Integración JAVA8 de CLAVE2 para que se conecte contra el SP de pruebas con providerName '21114293V_E04975701' (configurado en 'Config\sp.properties'), del entorno de Servicios Estables.



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.1.3] - 17-MAY-2022
-- CLV21-142_Caducidad_certificado_firma_INT_PRE
 - En el SP del Kit de Integración JAVA8 de CLAVE2 se han hecho algunas modificaciones a nivel de configuración a raíz de un nuevo certificado que nos han enviado, ya que el anterior estaba caducado. Tarea relacionada 'CLV21-130_Actualizar_certificado_firma_SP2_hacia_Pasarela_en_INT_y_PRE'



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.1.2] - 18-FEB-2022
-- CLV21-41_Incidencia_1058187_Error_con_despliegue_Pack_de_Integracion_Java_8
 - En la v2.1.1 del INTEGRADOR de CLAVE JAVA8 se muestra el siguiente error cuando el SP recibe la respuesta de la Pasarela de Cl@ve:
	"javax.servlet.ServletException: javax.servlet.ServletException: java.lang.IllegalStateException: java.lang.NoSuchMethodError: org.apache.commons.lang.StringUtils.lowerCase(Ljava/lang/String;Ljava/util/Locale;)Ljava/lang/String;
		es.clave.sp.security.ContentSecurityPolicyFilter.doFilter(ContentSecurityPolicyFilter.java:74)
		es.clave.sp.security.SecurityRequestFilter.doFilter(SecurityRequestFilter.java:61)
		org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:197)
		org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)"
		
 - Para solucionarlo, hay que indicar que la librería 'commons-lang' consuma la v2.6 en lugar de la v2.4 (como está ahora).
 - Por tanto, procedemos a incluir la siguiente dependencia el el 'pom.xml' del SP2 del KIT.
	 <dependency>
		<groupId>commons-lang</groupId>
		<artifactId>commons-lang</artifactId>
		<version>2.6</version>
	</dependency>



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.1.1] - 26-OCT-2021
-- CLV20-606_Incidencia_1017777_Actualizacion_pack_integracion_Java_del_1.7_al_1.8
 - En el proceso de actualización de la v2.0.3 del integrador CLAVE Java7 a la v2.1 del integrador CLAVE Java8, da el siguiente error al compilar:
	"Could not find artifact es.gob.sgad:clave-j20068.saml-engine:pom:2.7 in repoDependencias (file://Dependencias)"
 - Se ha comprobado que el integrador CLAVE v2.1 no estaba compilando bien, así que se han aportado dentro de la carpeta 'Dependencias' las librerías que le faltaban.



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.1] - 08-SEP-2021
-- CLV20-457_Error_Kit_Integracion_8_v2.0.2_No_private_key_entry_matching_serialNumber
 - ACTUALIZACIÓN DE LA LIBRERÍA DE CLAVE2 'es\gob\sgad\clave-j20068.eidas-saml-engine\2.7\clave-j20068.eidas-saml-engine-2.7.jar' y AFECTACIÓN en el KIT de INTEGRACIÓN de CLAVE JAVA 8
 
 - Antes de la v2.7 del proyecto de CLAVE2 se estaba detectando un error de validación del certificado contenido dentro del 'KeyStore.jks' en el KIT de INTEGRACIÓN de CLAVE JAVA 8. Solo en determinadas ocasiones, el flujo de autenticación de un usuario a través de su certificado no funcionaba correctamente. Se explica lo que pasaba a continuación.
 
 - Dentro de la librería 'es\gob\sgad\clave-j20068.eidas-saml-engine\2.7\clave-j20068.eidas-saml-engine' existe la clase 'eu\eidas\auth\engine\xml\opensaml\CertificateUtil.java'. En esta clase está la función pública 'matchesCertificate()', y el siguiente 'if' da 'false', cuando debería dar 'true', ya que se le están comparando dos STRING idénticos:
		return serialNumberBigInteger.equals(certificateSerialNumber) && (
                issuerPrincipal.equals(unencodedCertificateSubjectPrincipal) || issuerPrincipal.equals(
                        unencodedCertificateIssuerPrincipal));
 
 - Para solucionar el problema anterior, se ha actualizado a la v2.7 la librería 'es\gob\sgad\clave-j20068.eidas-saml-engine\2.7\clave-j20068.eidas-saml-engine-2.7.jar', y se ha añadido la clase 'eu\eidas\auth\engine\xml\opensaml\CertificateUtilES' y modificado todas las clases que llaman a su función pública 'matchesCertificate'.
 En esta nueva clase se utiliza la librería 'org.bouncycastle.asn1.x500.X500Name'. Antes, se utilizaba la antigua clase 'eu\eidas\auth\engine\xml\opensaml\CertificateUtil.java' que tiraba de la librería 'javax.security.auth.x500.X500Principal'.
 
 - Por tanto, se pasa a consumir la libería de 'org.bouncycastle' en lugar de la de 'javax.security'.
 
 - También se ha actualizado el 'pom.xml' raíz del KIT de INTEGRACIÓN de CLAVE JAVA 8, para que apunte a las librerías de CLAVE2 v2.7
 
 - Se actualiza también la carpeta 'Dependencias' del KIT de INTEGRACIÓN de CLAVE JAVA 8 con las librerías actualizadas de CLAVE2 v2.7
 
 - Tarea relacionada con la 'CLV20-386_Problemas_con_Kit_Java_para_firmar_los_tokens_SAML'



---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------
## [2.0.2] - 19-MAR-2020
 
### Added

### Changed

### Fixed
