package eu.stork.sp;

import java.io.IOException;
import java.util.Properties;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import eu.eidas.auth.engine.ProtocolEngineFactoryNoMetadata;
import eu.eidas.auth.engine.ProtocolEngineNoMetadataI;
import eu.eidas.auth.engine.configuration.dom.ProtocolEngineConfigurationFactoryNoMetadata;

public class SPUtil {

	/** Sistema de traceo. */
	static Log logger = LogFactory.getLog(SPUtil.class);
	
	static ProtocolEngineConfigurationFactoryNoMetadata protocolEngineConfigurationFactory = null;
    static ProtocolEngineFactoryNoMetadata defaultProtocolEngineFactory = null;

	public static Properties loadConfigs(String path) throws IOException {
		Properties properties = new Properties();
		properties.load(SPUtil.class.getClassLoader().getResourceAsStream(path));
		return properties;
	}
	
	public static synchronized ProtocolEngineNoMetadataI getProtocolEngine() {
        if (defaultProtocolEngineFactory == null) {
            try {
            	protocolEngineConfigurationFactory = new ProtocolEngineConfigurationFactoryNoMetadata("SPSamlEngine.xml",
                		null, "C:/ClaveConfig/SP/");
                defaultProtocolEngineFactory = new ProtocolEngineFactoryNoMetadata(protocolEngineConfigurationFactory);
            } catch (Exception e) {
                logger.error("Error creating protocol engine factory : ", e);
            }
        }
        return defaultProtocolEngineFactory.getProtocolEngine(Constants.SP_CONF);
    }
}
